NodeModel (FreeMarker 2.3.35 API)
Description: declaration: package: freemarker.ext.dom, class: NodeModel

Package freemarker.ext.dom

# Class NodeModel

java.lang.Object
freemarker.ext.dom.NodeModel

All Implemented Interfaces:
  `freemarker.core._UnexpectedTypeErrorExplainerTemplateModel`, `WrapperTemplateModel`, `AdapterTemplateModel`, `TemplateHashModel`, `TemplateModel`, `TemplateNodeModel`, `TemplateNodeModelEx`, `TemplateSequenceModel`

public abstract class NodeModel extends Object implements TemplateNodeModelEx, TemplateHashModel, TemplateSequenceModel, AdapterTemplateModel, WrapperTemplateModel, freemarker.core._UnexpectedTypeErrorExplainerTemplateModel
A base class for wrapping a single W3C DOM Node as a FreeMarker template model.

Note that `DefaultObjectWrapper` automatically wraps W3C DOM `Node`-s into this, so you may need do that with this class manually. However, before dropping the `Node`-s into the data-model, you certainly want to apply `simplify(Node)` on them.

This class is not guaranteed to be thread safe, so instances of this shouldn't be used as shared variable ( `Configuration.setSharedVariable(String, Object)`).

To represent a node sequence (such as a query result) of exactly 1 nodes, this class should be used instead of `NodeListModel`, as it adds extra capabilities by utilizing that we have exactly 1 node. If you need to wrap a node sequence of 0 or multiple nodes, you must use `NodeListModel`.

- ## Field Summary

  ### Fields inherited from interface freemarker.template.TemplateModel

  `NOTHING`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `NodeModel​(Node node)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals​(Object other)`
  `TemplateModel`
  `exec​(List args)`
  `Object[]`
  `explainTypeError​(Class[] expectedClasses)`
  `TemplateModel`
  `get​(int i)`
  Retrieves the i-th template model in this sequence.
  `TemplateModel`
  `get​(String key)`
  Gets a `TemplateModel` from the hash.
  `Object`
  `getAdaptedObject​(Class hint)`
  Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
  `TemplateSequenceModel`
  `getChildNodes()`
  `static DocumentBuilderFactory`
  `getDocumentBuilderFactory()`
  Deprecated.
  The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
  `static ErrorHandler`
  `getErrorHandler()`
  `TemplateNodeModelEx`
  `getNextSibling()`
  `Node`
  `getNode()`
  `String`
  `getNodeNamespace()`
  `String`
  `getNodeType()`
  `TemplateNodeModel`
  `getParentNode()`
  `TemplateNodeModelEx`
  `getPreviousSibling()`
  `Object`
  `getWrappedObject()`
  Retrieves the original object wrapped by this model.
  `static Class`
  `getXPathSupportClass()`
  Get the currently used freemarker.ext.dom.XPathSupport used as the XPath engine.
  `int`
  `hashCode()`
  `static void`
  `mergeAdjacentText​(Node parent)`
  Merges adjacent text nodes (where CDATA counts as text node too).
  `static NodeModel`
  `parse​(File f)`
  Deprecated.
  The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
  `static NodeModel`
  `parse​(File f, boolean removeComments, boolean removePIs)`
  Deprecated.
  The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
  `static NodeModel`
  `parse​(InputSource is)`
  Deprecated.
  The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
  `static NodeModel`
  `parse​(InputSource is, boolean removeComments, boolean removePIs)`
  Deprecated.
  The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see earlier what do instead.
  `static void`
  `removeComments​(Node parent)`
  Recursively removes all comment nodes from the subtree.
  `static void`
  `removePIs​(Node parent)`
  Recursively removes all processing instruction nodes from the subtree.
  `static void`
  `setDocumentBuilderFactory​(DocumentBuilderFactory docBuilderFactory)`
  Deprecated.
  It's a bad practice to change static fields, as if multiple independent components do that in the same JVM, they unintentionally affect each other.
  `static void`
  `setErrorHandler​(ErrorHandler errorHandler)`
  Deprecated.
  It's a bad practice to change static fields, as if multiple independent components do that in the same JVM, they unintentionally affect each other.
  `static void`
  `setXPathSupportClass​(Class cl)`
  Set an alternative implementation of freemarker.ext.dom.XPathSupport to use as the XPath engine.
  `static void`
  `simplify​(Node parent)`
  Removes all comments and processing instruction, and unites adjacent text nodes (here CDATA counts as text as well).
  `int`
  `size()`
  Always returns 1.
  `static void`
  `useDefaultXPathSupport()`
  Tells the system to use (restore) the default (initial) XPath system used by this FreeMarker version on this system.
  `static void`
  `useJaxenXPathSupport()`
  Convenience method.
  `static void`
  `useSunInternalXPathSupport()`
  `static void`
  `useXalanXPathSupport()`
  Convenience method.
  `static NodeModel`
  `wrap​(Node node)`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface freemarker.template.TemplateHashModel

  `isEmpty`

  ### Methods inherited from interface freemarker.template.TemplateNodeModel

  `getNodeName`

- ## Constructor Details

  - ### NodeModel

    protected NodeModel​(Node node)

- ## Method Details

  - ### setDocumentBuilderFactory

    @Deprecated public static void setDocumentBuilderFactory​(DocumentBuilderFactory docBuilderFactory)
    Deprecated.
    It's a bad practice to change static fields, as if multiple independent components do that in the same JVM, they unintentionally affect each other. Therefore, it's recommended to leave this static value at its default.
    Sets the DOM parser implementation to be used when building `NodeModel` objects from XML files or from `InputStream` with the static convenience methods of `NodeModel`. Otherwise, FreeMarker itself doesn't use this.
    See Also:
      `getDocumentBuilderFactory()`

  - ### getDocumentBuilderFactory

    @Deprecated public static DocumentBuilderFactory getDocumentBuilderFactory()
    Deprecated.
    The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
    Returns the DOM parser implementation that is used when building `NodeModel` objects from XML files or from `InputStream` with the static convenience methods of `NodeModel`. Otherwise, FreeMarker itself doesn't use this.
    See Also:
      `setDocumentBuilderFactory(DocumentBuilderFactory)`

  - ### setErrorHandler

    @Deprecated public static void setErrorHandler​(ErrorHandler errorHandler)
    Deprecated.
    It's a bad practice to change static fields, as if multiple independent components do that in the same JVM, they unintentionally affect each other. Therefore, it's recommended to leave this static value at its default.
    Sets the error handler to use when parsing the document with the static convenience methods of `NodeModel`.
    See Also:
      `getErrorHandler()`

  - ### getErrorHandler

    public static ErrorHandler getErrorHandler()
    Since:
      2.3.20
    See Also:
      `setErrorHandler(ErrorHandler)`

  - ### parse

    @Deprecated public static NodeModel parse​(InputSource is, boolean removeComments, boolean removePIs) throws SAXException, IOException, ParserConfigurationException
    Deprecated.
    The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see earlier what do instead.
    Convenience method to create a `NodeModel` from a SAX `InputSource`; please see the security warning further down. Adjacent text nodes will be merged (and CDATA sections are considered as text nodes) as with `mergeAdjacentText(Node)`. Further simplifications are applied depending on the parameters. If all simplifications are turned on, then it applies `simplify(Node)` on the loaded DOM.

    Note that `parse(...)` is only a convenience method, and FreeMarker itself doesn't use it (except when you call the other similar static convenience methods, as they may build on each other). In particular, if you want full control over the `DocumentBuilderFactory` used, create the `Node` with your own `DocumentBuilderFactory`, apply `simplify(Node)` (or such) on it, then call `wrap(Node)`.

    Security warning: If the XML to load is coming from a source that you can't fully trust, you shouldn't use this method, as the `DocumentBuilderFactory` it uses by default supports external entities, and so it doesn't prevent XML External Entity (XXE) attacks. Note that XXE attacks are not specific to FreeMarker, they affect all XML parsers in general. If that's a problem in your application, OWASP has a cheat sheet to set up a `DocumentBuilderFactory` that has limited functionality but is immune to XXE attacks. Because it's just a convenience method, you can just use your own `DocumentBuilderFactory` and do a few extra steps instead (see earlier). Appart from the OWASP recommended features, it's recommended to set `DocumentBuilderFactory.setNamespaceAware(boolean)` and `DocumentBuilderFactory.setIgnoringElementContentWhitespace(boolean)` set to `true`.

    Parameters:
      `removeComments` - Whether to remove all comment nodes (recursively); this is like calling `removeComments(Node)`
      `removePIs` - Whether to remove all processing instruction nodes (recursively); this is like calling `removePIs(Node)`
    Throws:
      `SAXException`
      `IOException`
      `ParserConfigurationException`

  - ### parse

    @Deprecated public static NodeModel parse​(InputSource is) throws SAXException, IOException, ParserConfigurationException
    Deprecated.
    The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
    Same as `parse(is, true, true)`; don't miss the security warnings documented there.
    Throws:
      `SAXException`
      `IOException`
      `ParserConfigurationException`

  - ### parse

    @Deprecated public static NodeModel parse​(File f, boolean removeComments, boolean removePIs) throws SAXException, IOException, ParserConfigurationException
    Deprecated.
    The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
    Same as `parse(InputSource, boolean, boolean)`, but loads from a `File`; don't miss the security warnings documented there.
    Throws:
      `SAXException`
      `IOException`
      `ParserConfigurationException`

  - ### parse

    @Deprecated public static NodeModel parse​(File f) throws SAXException, IOException, ParserConfigurationException
    Deprecated.
    The returned `DocumentBuilderFactory` is by default NOT SAFE from XXE attacks; see `parse(InputSource, boolean, boolean)` for more details!
    Same as `parse(source, true, true)`, but loads from a `File`; don't miss the security warnings documented there.
    Throws:
      `SAXException`
      `IOException`
      `ParserConfigurationException`

  - ### getNode

    public Node getNode()
    Returns:
      the underling W3C DOM Node object that this TemplateNodeModel is wrapping.

  - ### get

    public TemplateModel get​(String key) throws TemplateModelException
    Description copied from interface: `TemplateHashModel`
    Gets a `TemplateModel` from the hash.
    Specified by:
      `get` in interface `TemplateHashModel`
    Parameters:
      `key` - The name by which the `TemplateModel` is identified in the template.
    Returns:
      The `TemplateModel` referred to by the key, or `null` if not found.
    Throws:
      `TemplateModelException`

  - ### getParentNode

    public TemplateNodeModel getParentNode()
    Specified by:
      `getParentNode` in interface `TemplateNodeModel`
    Returns:
      the parent of this node or null, in which case this node is the root of the tree.

  - ### getPreviousSibling

    public TemplateNodeModelEx getPreviousSibling() throws TemplateModelException
    Specified by:
      `getPreviousSibling` in interface `TemplateNodeModelEx`
    Returns:
      The immediate previous sibling of this node, or `null` if there's no such node.
    Throws:
      `TemplateModelException`

  - ### getNextSibling

    public TemplateNodeModelEx getNextSibling() throws TemplateModelException
    Specified by:
      `getNextSibling` in interface `TemplateNodeModelEx`
    Returns:
      The immediate next sibling of this node, or `null` if there's no such node.
    Throws:
      `TemplateModelException`

  - ### getChildNodes

    public TemplateSequenceModel getChildNodes()
    Specified by:
      `getChildNodes` in interface `TemplateNodeModel`
    Returns:
      a sequence containing this node's children. If the returned value is null or empty, this is essentially a leaf node.

  - ### getNodeType

    public final String getNodeType() throws TemplateModelException
    Specified by:
      `getNodeType` in interface `TemplateNodeModel`
    Returns:
      a String describing the type of node this is. In the W3C DOM, this should be "element", "text", "attribute", etc. A TemplateNodeModel implementation that models other kinds of trees could return whatever it appropriate for that application. It can be null, if you don't want to use node-types.
    Throws:
      `TemplateModelException`

  - ### exec

    public TemplateModel exec​(List args) throws TemplateModelException
    Throws:
      `TemplateModelException`

  - ### size

    public final int size()
    Always returns 1.
    Specified by:
      `size` in interface `TemplateSequenceModel`
    Returns:
      the number of items in the list.

  - ### get

    public final TemplateModel get​(int i)
    Description copied from interface: `TemplateSequenceModel`
    Retrieves the i-th template model in this sequence.
    Specified by:
      `get` in interface `TemplateSequenceModel`
    Returns:
      the item at the specified index, or `null` if the index is out of bounds. Note that a `null` value is interpreted by FreeMarker as "variable does not exist", and accessing a missing variables is usually considered as an error in the FreeMarker Template Language, so the usage of a bad index will not remain hidden, unless the default value for that case was also specified in the template.

  - ### getNodeNamespace

    public String getNodeNamespace()
    Specified by:
      `getNodeNamespace` in interface `TemplateNodeModel`
    Returns:
      the XML namespace URI with which this node is associated. If this TemplateNodeModel implementation is not XML-related, it will almost certainly be null. Even for XML nodes, this will often be null.

  - ### hashCode

    public final int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals​(Object other)
    Overrides:
      `equals` in class `Object`

  - ### wrap

    public static NodeModel wrap​(Node node)

  - ### removeComments

    public static void removeComments​(Node parent)
    Recursively removes all comment nodes from the subtree.
    See Also:
      `simplify(org.w3c.dom.Node)`

  - ### removePIs

    public static void removePIs​(Node parent)
    Recursively removes all processing instruction nodes from the subtree.
    See Also:
      `simplify(org.w3c.dom.Node)`

  - ### mergeAdjacentText

    public static void mergeAdjacentText​(Node parent)
    Merges adjacent text nodes (where CDATA counts as text node too). Operates recursively on the entire subtree. The merged node will have the type of the first node of the adjacent merged nodes.

    Because XPath assumes that there are no adjacent text nodes in the tree, not doing this can have undesirable side effects. Xalan queries like `text()` will only return the first of a list of matching adjacent text nodes instead of all of them, while Jaxen will return all of them as intuitively expected.

    See Also:
      `simplify(org.w3c.dom.Node)`

  - ### simplify

    public static void simplify​(Node parent)
    Removes all comments and processing instruction, and unites adjacent text nodes (here CDATA counts as text as well). This is similar to applying `removeComments(Node)`, `removePIs(Node)`, and finally `mergeAdjacentText(Node)`, but it does all that somewhat faster.

  - ### useDefaultXPathSupport

    public static void useDefaultXPathSupport()
    Tells the system to use (restore) the default (initial) XPath system used by this FreeMarker version on this system.

  - ### useJaxenXPathSupport

    public static void useJaxenXPathSupport() throws Exception
    Convenience method. Tells the system to use Jaxen for XPath queries.
    Throws:
      `Exception` - if the Jaxen classes are not present.

  - ### useXalanXPathSupport

    public static void useXalanXPathSupport() throws Exception
    Convenience method. Tells the system to use Xalan for XPath queries.
    Throws:
      `Exception` - if the Xalan XPath classes are not present.

  - ### useSunInternalXPathSupport

    public static void useSunInternalXPathSupport() throws Exception
    Throws:
      `Exception`

  - ### setXPathSupportClass

    public static void setXPathSupportClass​(Class cl)
    Set an alternative implementation of freemarker.ext.dom.XPathSupport to use as the XPath engine.
    Parameters:
      `cl` - the class, or `null` to disable XPath support.

  - ### getXPathSupportClass

    public static Class getXPathSupportClass()
    Get the currently used freemarker.ext.dom.XPathSupport used as the XPath engine. Returns `null` if XPath support is disabled.

  - ### getAdaptedObject

    public Object getAdaptedObject​(Class hint)
    Description copied from interface: `AdapterTemplateModel`
    Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
    Specified by:
      `getAdaptedObject` in interface `AdapterTemplateModel`
    Parameters:
      `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
    Returns:
      the underlying object, or its value accommodated for the hint class.

  - ### getWrappedObject

    public Object getWrappedObject()
    Description copied from interface: `WrapperTemplateModel`
    Retrieves the original object wrapped by this model.
    Specified by:
      `getWrappedObject` in interface `WrapperTemplateModel`

  - ### explainTypeError

    public Object[] explainTypeError​(Class[] expectedClasses)
    Specified by:
      `explainTypeError` in interface `freemarker.core._UnexpectedTypeErrorExplainerTemplateModel`